
\begin{code}
-- module Packet (Tag, Length, Packet(..)) where
module Packet where

import Word

type Key = Int
type Length = Int
type Tag = Int
type AlgID = Int
type Count = Int
-- type Salt = Integer
type Salt = String
-- XXX incomplete
data SymAlg = CAST5
    deriving Show
-- XXX incomplete
data Hash = MD5 | SHA1
    deriving Show
data S2K = SimpleS2K Hash
         | SaltedS2K Hash Salt
         | IteratedSaltedS2K Hash Salt Count
    deriving Show
data CompAlg = ZIP
    deriving Show
data Mode = Binary | Text | Local deriving Show
type Filename = String
type Date = Word32
data Packet = T1_PK_ESK Int Key Int [Int]
            | T3_SK_ESK SymAlg S2K (Maybe [Int])
            | T8_CD CompAlg [Int]
            | T9_SED [Int]
            | T11_LD Mode Filename Date String
            | Other Tag [Int]
    deriving Show
\end{code}

